#!/usr/bin/python3
# -*- coding: iso-8859-1 -*-
#19/12/2022

import time
import serial
import curses
import os
import sys

import array


#__________________________________________________________________

def print_there(x, y, text):
     sys.stdout.write("\x1b7\x1b[%d;%df%s\x1b8" % (y, x, text))
     sys.stdout.flush()

#----------------------------------------------------------

mensaje="Esperando datos "+'...'+ """<br>"""+'\n'

def make_web():
            print ("Crear pagina")
            fw = open('index.html','w')

            mensajeWeb = """
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <title>PALENCIA</title>
</head>
<body bgcolor="#ffff99">
<h2>Palencia, Spain
<hr size="2" width="100%">
"""
            mensajeWeb = mensajeWeb + mensaje
            mensajeWeb = mensajeWeb + """
<img alt="" src="xgrados.png" > <br>
<img alt="" src="xbar.png" >
</h2>           
</body>
</html>"""

            fw.write(mensajeWeb)
            fw.close()



#Busqueda de port serial  arduino sensores
puertos=['/dev/ttyUSB0','/dev/ttyUSB1','/dev/ttyACM0','/dev/ttyACM1','/dev/ttyACM2','/dev/ttyS0' ]
portOK=0;
namePort=""
clave="SENSORTOTAL5"

os.system('clear')      #linux  -Para windows os.system('cls')
print ("ESPERANDO 1Segundos")
time.sleep(1)


count = 0
while count < len(puertos): 
    try:
        arduinoPort = serial.Serial(puertos[count], 9600, timeout=1)
    except:
        print ("ERROR dispositivo " + puertos[count])
    else:
        print ("OK dispositivo " + puertos[count])
        arduinoPort.flushInput()
        print ("Clear buffer y espera 1S")
        time.sleep(1)
        DataSerial = arduinoPort.readline()
        DataSerial = DataSerial.rstrip(b'\r\n')
        DataSerial=DataSerial.decode("utf-8")
        print ("DATO=" + DataSerial + "<-")
        if DataSerial==clave:
            print ("***PORTOK***")
            portOK=1
            namePort=puertos[count]
            break
    count+=1

#----------------
def main(stdscr):
    """checking for keypress"""
    stdscr.nodelay(True)  # do not wait for input when calling getch
    return stdscr.getch()

#-------------
#inicializar 


dTemperatura=0
TemperaturaBMP=float(0)
dPresion=float(0)

dTemperaturaS=0
TemperaturaBMPS=float(0)
dPresionS=float(0)

ultimoM=100
dCHECKSUM=0

#-------------

miTime=1

if portOK==0:
    print ("No se encontraron sensores" )
else:
 while True:
    tecla=curses.wrapper(main)
    if tecla==113 or tecla==27:
            break
    DataSerial = arduinoPort.readline()
    DataSerial = DataSerial.rstrip(b'\r\n')
    DataSerial=DataSerial.decode("utf-8")
    if DataSerial!= "":
       if DataSerial== "INICIO":
          os.system('clear')        #linux  -Para windows os.system('cls')
          messageA = time.strftime("%d/%m/%y") +"  "+time.strftime("%H:%M:%S")
          print(messageA)
       print(DataSerial)
       
       if DataSerial[0:7]=='Grados=':
          dTemperatura = float(DataSerial[7:])
       if DataSerial[0:5]=='BMP1=':
          TemperaturaBMP = float(DataSerial[5:])
       if DataSerial[0:5]=='BMP2=':
          dPresion = float(DataSerial[5:])
       if DataSerial[0:6]=='Canal=':
          dCanal = int(DataSerial[6:])
       if DataSerial[0:9]=='CHECKSUM=':
          dCHECKSUM = int(DataSerial[9:])
          
       if DataSerial== "FINAL" and dCHECKSUM==1 and dCanal==1:
           print ("------------------")
           print("CANAL      =", end="")
           print (dCanal)
           print("TEMPERATURA=", end="")
           dTemperaturaS=dTemperatura/10
           mensaje='Temperatura='+ str(dTemperaturaS)+' C'+ """<br>"""+'\n'
           print (dTemperaturaS)
           print("PRESIN    =", end="")
           dPresionS=dPresion/10
           print (dPresionS)
           mensaje=mensaje+ 'Presin='+str(dPresionS)+' Bar'+ """<br>"""+'\n'
           print("TEMPERATURA_BMP=", end="")
           TemperaturaBMPS=TemperaturaBMP/10
           print (TemperaturaBMPS)
           mensaje=mensaje+'Temp.Interior='+str(TemperaturaBMPS)+' C'+ """<br>"""+'\n'
           print(time.strftime("ULTIMO -> %H:%M:%S"))
           mensaje = mensaje + time.strftime("%d/%m/20%y") +"  "+ time.strftime("%H:%M:%S") + """<br>"""+'\n' 
           print ("------------------")         
           print ("--ESC or Q -----EXIT--")

       time.sleep(0.01)
    else:
        zzm=int(time.strftime("%M"))
        zzh=int(time.strftime("%H"))
        if ultimoM!=zzm:
                    ultimoM=zzm
                    miTime-=1
                    if miTime<1:
                        miTime=2
                        make_web()

                    nombreFichero="Temp20"+time.strftime("%y_%m_%d")+".csv"
                    f = open(nombreFichero,'a')
                    f.write(time.strftime("%H,%M"))
                    f.write(',')
                    f.write(str(dTemperaturaS)+','+  str(dPresionS) +','+ str(TemperaturaBMPS) +','+'\n')
                    f.close()
                    
        print_there(25,0,time.strftime("%H:%M:%S"))
        time.sleep(0.5)
        
try:
    arduinoPort.close()
except:
    print ("Puerto no abierto")
print ("Programa finalizado")

